Return-Path: <PDK@ADMIN.DRAKE.EDU>
Received: from vuse.vanderbilt.edu ([129.59.100.1]) by idnsun.gpct.Vanderbilt.Edu.noname (4.1/SMI-4.1)
	id AA20904; Fri, 13 Oct 95 17:00:40 CDT
Received: from ctrvx1.Vanderbilt.Edu by vuse.vanderbilt.edu (8.6.12/SMI-4.1/VUSE-1.15)
	id RAA26361; Fri, 13 Oct 1995 17:08:39 -0500
Resent-Date: Fri, 13 Oct 1995 17:08:39 -0500
Resent-From: PDK@ADMIN.DRAKE.EDU
From: PDK@ADMIN.DRAKE.EDU
Received: from ctrvax.Vanderbilt.Edu by ctrvax.Vanderbilt.Edu
 (PMDF V5.0-5 #11488) id <01HWEDPJ7AV68XDUVD@ctrvax.Vanderbilt.Edu> for
 stst@vuse.vanderbilt.edu; Fri, 13 Oct 1995 17:08:08 -0500 (CDT)
Received: from helios (helios.Vanderbilt.Edu)
 by ctrvax.Vanderbilt.Edu (PMDF V5.0-5 #11488)
 id <01HWEDPDKHJK8XBSLK@ctrvax.Vanderbilt.Edu> for
 stracks@ctrvax.Vanderbilt.Edu; Fri, 13 Oct 1995 17:08:00 -0500 (CDT)
Received: by helios (5.0/SMI-SVR4) id AA26963; Fri, 13 Oct 1995 17:08:21 +0600
Received: from ADMIN.DRAKE.EDU by helios (5.0/SMI-SVR4) id AA26958; Fri,
 13 Oct 1995 17:08:18 +0600
Received: from ADMIN.DRAKE.EDU by ADMIN.DRAKE.EDU (PMDF V4.2-11 #11108)
 id <01HWEAY5AV2O00050J@ADMIN.DRAKE.EDU>; Fri, 13 Oct 1995 15:54:13 -0500 (CDT)
Date: Fri, 13 Oct 1995 15:54:13 -0500 (CDT)
Subject: NSFCWT Entry
Resent-To: stst@vuse.vanderbilt.edu
To: Stefan.Strack@vanderbilt.edu
Resent-Message-Id: <01HWEDPJ7U5G8XDUVD@ctrvax.Vanderbilt.Edu>
Message-Id: <01HWEAY5BECY00050J@ADMIN.DRAKE.EDU>
X-Vms-To: IN%"Stefan.Strack@vanderbilt.edu"
Mime-Version: 1.0
Content-Type: TEXT/PLAIN; CHARSET=US-ASCII
Content-Transfer-Encoding: 7BIT
X-Ph: V4.4@helios
Status: R

;redcode-94m verbose
;name Die Hard
;kill Die Hard
;author P.Kline
;contact pk6811s@acad.drake.edu
;NSFCWT Round 1
;assert CORESIZE == 8000
;strategy don't die
;
; Quick-scan a small portion of core
;    vamp anything found into the pit
;    the pit does a brainwash as well as core-clear
; Die Hard - replicate continuous ring-launchers (ala Keystone)
;    incorporating mov/add bomb logic from Paper Dreaming
; The brainwash forces pspacers to their default - usually 
; some stand-still program which Die Hard can kill
;
space    equ (4-40*127)
boot     equ (30*127+50)
dv       equ (c0+58)
dvins    mov   101,{1               ; pretty good bomb

qstep    dat    -8,8
qfang    jmp    qpit-qcomp+8,qcomp-8
start    seq    qcomp+(100*01),qcomp+(100*02)   ; quick-scan small part of core
         mov.ab #(100*01),*qcptr
         seq    qcomp+(100*03),qcomp+(100*04)
         mov.ab #(100*03),*qcptr
         seq    qcomp+(100*05),qcomp+(100*06)
         mov.ab #(100*05),*qcptr
         seq    qcomp+(100*07),qcomp+(100*08)
         mov.ab #(100*07),*qcptr
qcptr    jmn.b  qcomp,qcomp
         seq    qcomp+(100*09),qcomp+(100*10)
         mov.ab #(100*09),*qcptr
         seq    qcomp+(100*11),qcomp+(100*12)
         mov.ab #(100*11),*qcptr
         seq    qcomp+(100*13),qcomp+(100*14)
         mov.ab #(100*13),*qcptr
         seq    qcomp+(100*15),qcomp+(100*16)
         mov.ab #(100*15),*qcptr
         
         jmz.b  dh,qcomp
qcomp    sne    -200,0           ; which of two pointers was it?
         add    #100,qcomp
         add.b  qcomp,qfang      ; adjust fang
         sub.ba qcomp,qfang
         mov    qfang,@qfang     ; drop 6 fangs
         add    qstep,qfang
         mov    qfang,@qfang
         add    qstep,qfang
         djn    -4,#3            ; can't take too much time!
         
dh       mov dvins,dv+boot       ; position dv-bomb as needed
         mov dvins,dv
         spl 1,>-2002            ; make 8 processes
         spl 1,>-2001
         spl 1,>-2000
         mov <s2,{s2             ; boot one copy of Die Hard
s2       spl c0+boot+8,c0+8

c0       spl   @0,space          ; here is Die Hard
         mov   }c0,>c0
cs       spl   #0        ,}dv    ; following lines execute in reverse order
         mov   dv        ,}dv+space
cb       add.a #119      , dv+space
         spl   imp+5334  ,}dv+space
         spl   imp+2667  ,}dv+space
imp      mov.i #2667 ,*0
     for 36
         dat   0,0
     rof
qclr     dat   1,1
qpit     spl   0,0               ; the pit
         spl   -1,>1             ; washing with zero causes opponent
         stp.ab #0,#0            ;    to choose default stragy 
         mov    qclr,>1          ; self-destructive core-clear 
         jmp    -1,5
     for 5
         dat   0,0
     rof
         dat   start+1000,start+2000 ; small decoy for backward-scanners
         dat   start+1000,start+2000
         dat   start+1000,start+2000
         dat   start+1000,start+2000
         dat   start+1000,start+2000
         dat   1,1                   ; delay djn-stream overruns
         dat   1,1
         end start
